package main;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;

public class Main {
	public static String PIE;
	public static void main(String[] args) throws IOException {
		PIE = Files.readString(new File("Resources/pi_E6.txt").toPath()).replaceAll("[^0-9]", "");
		String text = Files.readString(new File("Resources/Goethe--Faust.txt").toPath()).toUpperCase().replaceAll("[^A-Z]", "");
		String[] piegenereKey = new String[] { "SDF", "JA", "HJZR", "M", "HTASBOATC", "NAFARTZQ", "FAFVB", "AF", "QDOP",
				"VCXY" };

		System.out.println("Orginal: \n" + text);
		String encrypted = viegenere(text, createViegenereKey(text.length(), piegenereKey), false);
		System.out.println("verschlüsselt: \n" + encrypted);
		System.out.println(
				"entschlüsselt \n" + viegenere(encrypted, createViegenereKey(text.length(), piegenereKey), true));
		Files.writeString(Path.of("Resources/Goethe--FaustEncrypted.txt"), encrypted);
		System.out.println(text.length() + "/" + encrypted.length());
	}

	public static String createViegenereKey(int length, String[] piegenereKey) {
		String result = "";
		int pos = 0;
		while (result.length() < length) {
			char current = PIE.charAt(pos++);
			result += piegenereKey[Integer.valueOf(current - '0')];
		}
		return result.substring(0, length);
	}

	public static String viegenere(String input, String key, boolean decrypt) {
		String result = "";
		int keypos = 0;
		for (int i = 0; i < input.length(); i++) {
			result += (char) (decrypt ? (input.charAt(i) - key.charAt(keypos) + 26) % 26 + 'A'
					: ((input.charAt(i) - 'A') + key.charAt(keypos) - 'A') % 26 + 'A');
			keypos++;
			keypos %= key.length();
		}
		return result;
	}
}
